/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.common;

import javax.servlet.http.HttpServletRequest;

/**
 * 携帯ユーザー判断ユーティリティ
 * @version		0.0.1
 * @since		
 * @author yoshida
 *
 */
public class MobileUserUtility {

	public static boolean isMobileUser(HttpServletRequest request) {
		String userAgent = request.getHeader("User-Agent");
		// HTTP_USER_AGENTから判断する。
		if (
				// Docomoの場合
				isDocomo(userAgent)
				// auの場合
				|| isKDDI(userAgent)
				// SoftBank、J-PHONE、Vodafoneの場合
				|| isSoftBank(userAgent)
		) {
			return true;
		}
		return false;
	}

	/**
	 * Docomo
	 * @param userAgent		対象HTTP_USER_AGENT
	 * @return
	 * <p>
	 * HTTP_USER_AGENTがDocomoの場合true、そうでない場合false
	 * </p>
	 */
	private static boolean isDocomo(String userAgent) {
		return userAgent.indexOf("DoCoMo") != -1;
	}

	/**
	 * au
	 * @param userAgent		対象HTTP_USER_AGENT
	 * @return
	 * <p>
	 * HTTP_USER_AGENTがauの場合true、そうでない場合false
	 * </p>
	 */
	private static boolean isKDDI(String userAgent) {
		return userAgent.indexOf("KDDI") != -1;
	}

	/**
	 * SoftBank、J-PHONE、Vodafone
	 * @param userAgent		対象HTTP_USER_AGENT
	 * @return
	 * <p>
	 * HTTP_USER_AGENTがSoftBank、J-PHONE、Vodafoneの場合true、
	 * そうでない場合false
	 * </p>
	 */
	private static boolean isSoftBank(String userAgent) {
		return (userAgent.indexOf("SoftBank") != -1)
		|| (userAgent.indexOf("Vodafone") != -1) 
		|| (userAgent.indexOf("J-PHONE") != -1);
	}

}
